"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createPermission: () => createPermission
});
module.exports = __toCommonJS(src_exports);
var import_solid_js = require("solid-js");
var createPermission = (name) => {
  const [permission, setPermission] = (0, import_solid_js.createSignal)("unknown");
  const [status, setStatus] = (0, import_solid_js.createSignal)();
  if (navigator) {
    navigator.permissions.query(typeof name === "string" ? { name } : name).then(setStatus).catch((error) => {
      if (error.name !== "TypeError" || name !== "microphone" && name !== "camera") {
        return;
      }
      setPermission("prompt");
      const constraint = name === "camera" ? "video" : "audio";
      const getUserMedia = navigator.mediaDevices.getUserMedia.bind(navigator.mediaDevices);
      navigator.mediaDevices.getUserMedia = (constraints) => (constraints == null ? void 0 : constraints[constraint]) ? getUserMedia(constraints).then((stream) => (setPermission("granted"), stream)).catch((error2) => {
        if (/not allowed/.test(error2.message)) {
          setPermission("denied");
        }
        return Promise.reject(error2);
      }) : getUserMedia(constraints);
    });
    (0, import_solid_js.createEffect)(
      (0, import_solid_js.on)(status, (status2) => {
        if (status2) {
          setPermission(status2.state);
          const listener = () => setPermission(status2.state);
          status2.addEventListener("change", listener);
          (0, import_solid_js.onCleanup)(() => status2.removeEventListener("change", listener));
        }
      })
    );
  }
  return permission;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createPermission
});
